#ifndef ACTION_H
#define ACTION_H

class Action
{
public:
	Action(const char *path);
	Action(const char *name, const char *server, unsigned short port, 
		const char *description, CTime when, int howLong);
	const CString& GetName() const;
	const CString& GetServer() const;
	unsigned short GetPort() const;
	CString GetPortStr() const;
	const CString& GetDescription() const;
	CTime GetWhen() const;
	int GetHowLong() const;
	CString GetHowLongStr() const;
	CString GetWhenStr() const;
	CString GetGuidStr() const;

	void MakeLove(const char* dir) const;
	
protected:

	CString m_name;
	CString m_server;
	unsigned short m_port;
	CString m_description;
	CTime m_when;
	int m_howLong;
	GUID m_guid;

	void SetGuidStr(const char *);
	static CTime StrToTime(const char *strTime);
};

#endif // ACTION_H