// ActionPage.cpp : implementation file
//

#include "stdafx.h"
#include "AntiMafia.h"
#include "Core\common.h"
#include "Core\Buffer.h"
#include "Core\Object.h"
#include "Core\String.h"
#include "Core\List.h"
#include "Core\FileWorker.h"
#include "Core\Connection.h"
#include "Core\GnutellaWorker.h"
#include "Core\Base.h"
#include "ActionPage.h"
#include "Action.h"
#include "DisplayAction.h"
#include "ActionManager.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CActionPage property page

IMPLEMENT_DYNCREATE(CActionPage, CPropertyPage)

CActionPage::CActionPage() : CPropertyPage(CActionPage::IDD)
{
	//{{AFX_DATA_INIT(CActionPage)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	dialogInitialized = false;
}

CActionPage::~CActionPage()
{
}

void CActionPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CActionPage)
	DDX_Control(pDX, IDC_ATTACKCOMBO, m_comboAttack);
	DDX_Control(pDX, IDC_ACTIONLIST, m_listAction);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CActionPage, CPropertyPage)
	//{{AFX_MSG_MAP(CActionPage)
	ON_NOTIFY(NM_DBLCLK, IDC_ACTIONLIST, OnDblclkActionlist)
	ON_BN_CLICKED(IDC_ATTACKBUTTON, OnAttackbutton)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CActionPage message handlers

BOOL CActionPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	int i;
	LV_COLUMN lvc;
	const int ncolumns = 6;
	CStringArray actions;
	CString path = global.options.downloadDir;
	if (path.Right(1) != "\\")
		path += "\\";


	ActionDll::GetAttackTypes(actions);
	m_comboAttack.AddString("none");
	for (i = 0; i < actions.GetSize(); i++)
		m_comboAttack.AddString(actions[i]);
	m_comboAttack.SetCurSel(0);

	char *ctitle[ncolumns] = {"Action Name", "When", "Duration", "Target", "Target Port", "Status"};
	int ctsize[ncolumns] = {80, 100, 100, 120, 80, 60} ; //{130, 65, 60, 70, 100};
	for (i = 0; i < ncolumns; i++)
	{
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
		lvc.iSubItem = i;
		lvc.cx = ctsize[i];
		lvc.fmt = LVCFMT_LEFT;
		lvc.pszText = ctitle[i];
		m_listAction.InsertColumn(lvc.iSubItem, &lvc);
	}

	ActionManager::Instance()->Load(path + "ActionsConfiguration.xml");
	ActionManager::Instance()->Synchronize();
	dialogInitialized = TRUE;
	UpdatePage();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CActionPage::UpdatePage()
{
	CFileFind finder;
	CString filter;
	BOOL found;

	if (!dialogInitialized)
		return;

	m_listAction.DeleteAllItems();
	m_loveNames.RemoveAll();
	filter = global.options.downloadDir;
	if (filter.Right(1) != "\\")
		filter += "\\";
	filter += "*.love";
	found = finder.FindFile(filter);
	while (found)
	{
		found = finder.FindNextFile();
		AddFileToListAction(finder.GetFilePath());
	}
}

void CActionPage::AddFileToListAction(const char *path)
{
	LV_ITEM lvi;
	int item;
	Action a(path);
	CString status;
	CString fileName;

	item = m_loveNames.Add(path);

	lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE; 
	lvi.state = 0; 
	lvi.stateMask = 0; 
	lvi.pszText = "";
	lvi.iImage = 0;
	lvi.iItem = item;
	lvi.iSubItem = 0;
	lvi.lParam = (LPARAM)item;
	item = m_listAction.InsertItem(&lvi);

	fileName = path;
	fileName = fileName.Mid(fileName.ReverseFind('\\') + 1);
	status = ActionManager::Instance()->GetStatus(fileName);

	m_listAction.SetItemText(item, Name, a.GetName());
	m_listAction.SetItemText(item, When, a.GetWhenStr());
	m_listAction.SetItemText(item, Duration, a.GetHowLongStr());
	m_listAction.SetItemText(item, Server, a.GetServer());
	m_listAction.SetItemText(item, Port, a.GetPortStr());
	m_listAction.SetItemText(item, Status, status);
}

BOOL CActionPage::OnSetActive() 
{
	UpdatePage();
	
	return CPropertyPage::OnSetActive();
}

void CActionPage::OnDblclkActionlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	CString txt;
	int iString;
	int item = ((NMITEMACTIVATE*) pNMHDR)->iItem;
	
	if (-1 == item)
		return;

	iString = m_listAction.GetItemData(item);
	Action a(m_loveNames[iString]);
	txt = a.GetName();
	txt += "\n";
	txt += a.GetWhenStr() + " for " + a.GetHowLongStr() + " minutes";
	txt += "\n";
	txt += a.GetServer() + ":" + a.GetPortStr();
	txt += "\n";
	txt += "\n";
	txt += a.GetDescription();

	CDisplayAction dlg(txt);
	dlg.DoModal();

	*pResult = 0;
}

void CActionPage::OnAttackbutton() 
{
	CString attackType;
	int attackIndex;
	POSITION pos;

	attackIndex = m_comboAttack.GetCurSel();
	if (attackIndex == LB_ERR)
		return;
	m_comboAttack.GetLBText(attackIndex, attackType);
	pos = m_listAction.GetFirstSelectedItemPosition();
	while (NULL != pos)
	{
		int item = m_listAction.GetNextSelectedItem(pos);
		int iName = m_listAction.GetItemData(item);
		CString pathOfAction = m_loveNames[iName];
		CString nameOfAction = pathOfAction.Mid(pathOfAction.ReverseFind('\\') + 1);
		ActionManager::Instance()->ScheduleAction(nameOfAction, attackType);
		ActionManager::Instance()->Configure(nameOfAction);
	}
	UpdatePage();
}

void CActionPage::OnDestroy() 
{
	CString path = global.options.downloadDir;
	if (path.Right(1) != "\\")
		path += "\\";

	CPropertyPage::OnDestroy();
	AttackThread::TerminateAllAttackerThreads();
	ActionManager::Instance()->Save(path + "ActionsConfiguration.xml");	
}
