/******************************************************************************
*
* AntiMafia
* Copyright (C) 2002 by [epidemiC] AntiMafia
* Newtella
* Copyright (C) 2000 by Newtella Inc.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
******************************************************************************/


// AntiMafia.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include <nspapi.h>
#include <SVCGUID.H>
#include "AntiMafia.h"
#include "Core\common.h"
#include "Core\Buffer.h"
#include "Core\Object.h"
#include "Core\String.h"
#include "Core\List.h"
#include "Core\FileWorker.h"
#include "Core\Connection.h"
#include "Core\GnutellaWorker.h"
#include "Core\Base.h"
#include "ConnectionPage.h"
#include "ConfigPage.h"

#include "ActionPage.h"
#include "NewAction.h"
#include "AboutPage.h"

#include "AntiMafiaSheet.h"
#include "ConfigConnectionPage.h"
#include "ConfigDownloadPage.h"
#include "MyTime.h"


#define GetWindowSettings(s, n) global.##s = GetProfileInt("Window", #s, n)
#define SaveWindowSettings(s) WriteProfileInt("Window", #s, global.##s)


/////////////////////////////////////////////////////////////////////////////
// CAntiMafiaApp

BEGIN_MESSAGE_MAP(CAntiMafiaApp, CWinApp)
	//{{AFX_MSG_MAP(CAntiMafiaApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAntiMafiaApp construction

CAntiMafiaApp::CAntiMafiaApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CAntiMafiaApp object

CAntiMafiaApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CAntiMafiaApp initialization

BOOL CAntiMafiaApp::InitInstance()
{
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLEINIT_FAILED);
		return FALSE;
	}
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	SetRegistryKey("AntiMafia") ;
	global.options.programDir = (LPCTSTR)GetProfileString("Options", "ProgramDir", "");
	if (global.options.programDir.GetLength() && global.options.programDir.Left(1) != String("\\")) global.options.programDir += "\\" ;

	GnutellaWorker gnut;
	gnutella = &gnut;
// Application initialization
	global.hInst = m_hInstance;
	global.hWnd = NULL;
	global.options.searchTTL = GetProfileInt("Options", "searchTTL", 7);
	global.options.pingTTL = GetProfileInt("Options", "pingTTL", 7);
	global.options.downloadDir = (LPCTSTR)GetProfileString("Options", "DownloadDir", "");
	global.options.shareDir = (LPCTSTR)GetProfileString("Options", "UploadDir", "");
	global.options.ignoreResults = (LPCTSTR)GetProfileString("Options", "IgnoreResults", "xxx");
	global.options.connectionSpeed = GetProfileInt("Options", "ConnectionSpeed", 56);
	global.options.listenPort = (WORD)GetProfileInt("Options", "ListenPort", htons(6346));
	global.options.forcedIP = (DWORD)GetProfileInt("Options", "ForcedIP", 0);
	global.options.acceptIncoming = GetProfileInt("Options", "AcceptIncoming", TRUE);
	global.options.displayAll = GetProfileInt("Options", "DisplayAll", FALSE);
	global.options.killBuggyClients = GetProfileInt("Options", "KillBuggyClients", TRUE);
	global.options.searchTypes = (LPCTSTR)GetProfileString("Options", "searchTypes", "mp3");
	global.options.searchLimit = GetProfileInt("Options", "searchLimit", 255);
	global.options.minConnections = GetProfileInt("Options", "MinConnections", 3);
	global.options.maxConnections = GetProfileInt("Options", "MaxConnections", 7);
	global.options.maxDownloads = GetProfileInt("Options", "MaxDownloads", 10);
	global.options.maxUploadstotal = GetProfileInt("Options", "MaxUploadsTotal", 10);
	global.options.maxUploadsperclient = GetProfileInt("Options", "MaxUploadsPerClient", 10);
	global.options.maxUploadBandwidth = GetProfileInt("Options", "MaxUploadBandwidth", 0);
	global.options.connectAutomatically = TRUE ;
	global.options.connectionType = GetProfileString("Wizard", "ConnectionType", "Modem");

	GetWindowSettings(WindowX, -1) ;
	GetWindowSettings(WindowY, -1) ;
	GetWindowSettings(WindowCX, 476) ;
	GetWindowSettings(WindowCY, 530) ;
	GetWindowSettings(WindowZoomed, 0) ;
	GetWindowSettings(SearchFile, 180) ;
	GetWindowSettings(SearchSize, 70) ;
	GetWindowSettings(SearchSpeed, 50) ;
	GetWindowSettings(SearchLocation, 100) ;
	GetWindowSettings(SearchReceived, 100) ;
	GetWindowSettings(ConnectionIP, 130) ;
	GetWindowSettings(ConnectionStatus, 90) ;
	GetWindowSettings(ConnectionPackets, 110) ;
	GetWindowSettings(ConnectionBandwidth, 80) ;
	GetWindowSettings(DownloadFile, 130) ;
	GetWindowSettings(DownloadSize, 65) ;
	GetWindowSettings(DownloadStatus, 60) ;
	GetWindowSettings(DownloadSpeed, 70) ;
	GetWindowSettings(DownloadServer, 100) ;
	GetWindowSettings(UploadFile, 130) ;
	GetWindowSettings(UploadSize, 65) ;
	GetWindowSettings(UploadStatus, 60) ;
	GetWindowSettings(UploadSpeed, 70) ;
	GetWindowSettings(UploadDownloader, 100) ;
	CMyTime::ReadUTime("TimeManagement");

	if (GetProfileInt("State", "Lock", 1))
		global.options.listenPort = htons(6346);
	WriteProfileInt("State", "Lock", 1);

	global.connectionID = 0;

// Configuration wizard
	
	int doWizard = GetProfileInt("State", "DoWizard", TRUE);
	if (doWizard)
	{
		CPropertySheet wizard;
		CConfigConnectionPage ConfigConnectionPage;
		CConfigDownloadPage ConfigDownloadPage;
		ConfigConnectionPage.parentSheet = &wizard;
		ConfigDownloadPage.parentSheet = &wizard;

		ConfigConnectionPage.m_Type = global.options.connectionType;
		ConfigDownloadPage.m_DownloadDir = global.options.downloadDir;

		wizard.AddPage(&ConfigConnectionPage);
		wizard.AddPage(&ConfigDownloadPage);
		wizard.SetWizardMode();
		if (wizard.DoModal() == IDCANCEL)
			return(FALSE);
		else
		{
			global.options.downloadDir = ConfigDownloadPage.m_DownloadDir;
			global.options.connectionType = ConfigConnectionPage.m_Type;
			global.options.connectionSpeed = ConfigConnectionPage.m_Speed;
			gnutella->BuildFileIndex();

			WriteProfileInt("State", "DoWizard", FALSE);
		}
	}

// PropertySheet initialization
	CAntiMafiaSheet dlg("AntiMafia 0.9b");
	dlg.AntiMafiaIcon = LoadIcon(IDR_MAINFRAME);
	dlg.errorIcon = LoadIcon(IDI_ERRORBUTTON);
	HICON AntiMafiaIcon = LoadIcon(IDR_MAINFRAME);
	dlg.m_psh.hIcon = AntiMafiaIcon;
	dlg.m_psh.dwFlags |= PSH_NOAPPLYNOW;
	dlg.m_psh.dwFlags |= PSH_USEHICON;
	dlg.m_psh.dwFlags &= ~PSH_HASHELP;
	dlg.ConnectionPage.ParentSheet = &dlg;
	dlg.ConnectionPage.m_psp.dwFlags |= PSP_PREMATURE ;


	dlg.ActionPage.ParentSheet = &dlg;
	dlg.ActionPage.m_psp.dwFlags |= PSP_PREMATURE;
	dlg.NewAction.ParentSheet = &dlg;
	dlg.NewAction.m_psp.dwFlags |= PSP_PREMATURE;
	dlg.AddPage(&dlg.ActionPage);
	dlg.AddPage(&dlg.ConnectionPage);
	dlg.AddPage(&dlg.NewAction);
	dlg.AboutPage.m_psp.dwFlags |= PSP_PREMATURE ;
	dlg.AddPage(&dlg.AboutPage);
	dlg.EnableStackedTabs(FALSE) ;
	m_pMainWnd = &dlg;

	dlg.DoModal();

	WriteProfileString("Wizard", "ConnectionType", global.options.connectionType);
	WriteProfileInt("Options", "MaxUploadBandwidth", global.options.maxUploadBandwidth);
	WriteProfileInt("Options", "MaxUploadsTotal", global.options.maxUploadstotal);
	WriteProfileInt("Options", "MaxUploadsPerClient", global.options.maxUploadsperclient);
	WriteProfileInt("Options", "MinConnections", global.options.minConnections);
	WriteProfileInt("Options", "MaxConnections", global.options.maxConnections);
	WriteProfileInt("Options", "MaxDownloads", global.options.maxDownloads);
	WriteProfileInt("Options", "searchTTL", global.options.searchTTL);
	WriteProfileInt("Options", "pingTTL", global.options.pingTTL);
	WriteProfileString("Options", "DownloadDir", global.options.downloadDir);
	WriteProfileString("Options", "UploadDir", global.options.shareDir);
	WriteProfileInt("Options", "ConnectionSpeed", global.options.connectionSpeed);
	WriteProfileString("Options", "IgnoreResults", global.options.ignoreResults);
	WriteProfileInt("Options", "ForcedIP", global.options.forcedIP);
	WriteProfileInt("Options", "ListenPort", global.options.listenPort);
	WriteProfileInt("Options", "AcceptIncoming", global.options.acceptIncoming);
	WriteProfileInt("Options", "DisplayAll", global.options.displayAll);
	WriteProfileInt("Options", "KillBuggyClients", global.options.killBuggyClients);
	WriteProfileString("Options", "searchTypes", global.options.searchTypes);
	WriteProfileInt("Options", "searchLimit", global.options.searchLimit);
	CMyTime::WriteUTime("TimeManagement");

	SaveWindowSettings(WindowX) ;
	SaveWindowSettings(WindowY) ;
	SaveWindowSettings(WindowCX) ;
	SaveWindowSettings(WindowCY) ;
	SaveWindowSettings(WindowZoomed) ;
	SaveWindowSettings(SearchFile) ;
	SaveWindowSettings(SearchSize) ;
	SaveWindowSettings(SearchSpeed) ;
	SaveWindowSettings(SearchLocation) ;
	SaveWindowSettings(SearchReceived) ;
	SaveWindowSettings(ConnectionIP) ;
	SaveWindowSettings(ConnectionStatus) ;
	SaveWindowSettings(ConnectionPackets) ;
	SaveWindowSettings(ConnectionBandwidth) ;
	SaveWindowSettings(DownloadFile) ;
	SaveWindowSettings(DownloadSize) ;
	SaveWindowSettings(DownloadStatus) ;
	SaveWindowSettings(DownloadSpeed) ;
	SaveWindowSettings(DownloadServer) ;
	SaveWindowSettings(UploadFile) ;
	SaveWindowSettings(UploadSize) ;
	SaveWindowSettings(UploadStatus) ;
	SaveWindowSettings(UploadSpeed) ;
	SaveWindowSettings(UploadDownloader) ;

	WriteProfileInt("State", "Lock", 0);

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
