/******************************************************************************
*
* AntiMafia
* Copyright (C) 2002 by [epidemiC] AntiMafia
* Newtella
* Copyright (C) 2000 by Newtella Inc.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
******************************************************************************/


// ConfigConnectionPage.cpp : implementation file
//

#include "stdafx.h"
#include "Core\common.h"
#include "Core\Buffer.h"
#include "Core\Object.h"
#include "Core\String.h"
#include "Core\List.h"
#include "Core\FileWorker.h"
#include "Core\Connection.h"
#include "Core\GnutellaWorker.h"
#include "Core\Base.h"
#include "AntiMafia.h"
#include "ConfigConnectionPage.h"

/////////////////////////////////////////////////////////////////////////////
// CConfigConnectionPage property page

IMPLEMENT_DYNCREATE(CConfigConnectionPage, CPropertyPage)

CConfigConnectionPage::CConfigConnectionPage() : CPropertyPage(CConfigConnectionPage::IDD)
{
	//{{AFX_DATA_INIT(CConfigConnectionPage)
	m_Speed = 0;
	m_Type = _T("");
	//}}AFX_DATA_INIT
}

CConfigConnectionPage::~CConfigConnectionPage()
{
}

void CConfigConnectionPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigConnectionPage)
	DDX_Control(pDX, IDC_SPEED, m_SpeedCtrl);
	DDX_Control(pDX, IDC_TYPE, m_TypeCtrl);
	DDX_Text(pDX, IDC_SPEED, m_Speed);
	DDX_CBString(pDX, IDC_TYPE, m_Type);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigConnectionPage, CPropertyPage)
	//{{AFX_MSG_MAP(CConfigConnectionPage)
	ON_EN_CHANGE(IDC_SPEED, OnChangeSpeed)
	ON_CBN_SELCHANGE(IDC_TYPE, OnSelchangeType)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigConnectionPage message handlers

void CConfigConnectionPage::OnChangeSpeed() 
{
	m_Type = "Custom...";
}

#define TYPE_MODEM 0
#define TYPE_ISDN 1
#define TYPE_ISDN2 2
#define TYPE_CABLEMODEM 3
#define TYPE_ADSL 4
#define TYPE_T1 5
#define TYPE_T3 6
#define TYPE_CUSTOM 7

BOOL CConfigConnectionPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	m_SpeedCtrl.EnableWindow(FALSE);
	m_TypeCtrl.SetCurSel(TYPE_MODEM);
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CConfigConnectionPage::OnSetActive() 
{
	parentSheet->SetWizardButtons(PSWIZB_NEXT);
	
	return CPropertyPage::OnSetActive();
}

void CConfigConnectionPage::OnSelchangeType() 
{
	int index = m_TypeCtrl.GetCurSel();
	UpdateData();
	if (index == TYPE_MODEM)
	{
		m_SpeedCtrl.EnableWindow(FALSE);
		m_Speed = 56;
	}
	else if (index == TYPE_ISDN)
	{
		m_SpeedCtrl.EnableWindow(FALSE);
		m_Speed = 64;
	}
	else if (index == TYPE_ISDN2)
	{
		m_SpeedCtrl.EnableWindow(FALSE);
		m_Speed = 128;
	}
	else if (index == TYPE_CABLEMODEM)
	{
		m_SpeedCtrl.EnableWindow(FALSE);
		m_Speed = 512;
	}
	else if (index == TYPE_ADSL)
	{
		m_SpeedCtrl.EnableWindow(FALSE);
		m_Speed = 768;
	}
	else if (index == TYPE_T1)
	{
		m_SpeedCtrl.EnableWindow(FALSE);
		m_Speed = 1024;
	}
	else if (index == TYPE_T3)
	{
		m_SpeedCtrl.EnableWindow(FALSE);
		m_Speed = 10000;
	}
	char tstr[4096];
	sprintf(tstr, "%d", m_Speed);
	m_SpeedCtrl.SetWindowText(tstr);
	if (index == TYPE_CUSTOM)
	{
		m_SpeedCtrl.EnableWindow();
		m_SpeedCtrl.SetFocus();
		m_SpeedCtrl.SetSel(0, -1);
	}
}
