/******************************************************************************
*
* AntiMafia
* Copyright (C) 2002 by [epidemiC] AntiMafia
* Newtella
* Copyright (C) 2000 by Newtella Inc.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
******************************************************************************/


// ConfigDownloadPage.cpp : implementation file
//

#include "stdafx.h"
#include "Core\common.h"
#include <direct.h>
#include <winnetwk.h>
#include <shlobj.h>
#include "AntiMafia.h"
#include "ConfigDownloadPage.h"

/////////////////////////////////////////////////////////////////////////////
// CConfigDownloadPage property page

IMPLEMENT_DYNCREATE(CConfigDownloadPage, CPropertyPage)

CConfigDownloadPage::CConfigDownloadPage() : CPropertyPage(CConfigDownloadPage::IDD)
{
	//{{AFX_DATA_INIT(CConfigDownloadPage)
	//}}AFX_DATA_INIT
}

CConfigDownloadPage::~CConfigDownloadPage()
{
}

void CConfigDownloadPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigDownloadPage)
	DDX_Control(pDX, IDC_BROWSE, m_Browse);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigDownloadPage, CPropertyPage)
	//{{AFX_MSG_MAP(CConfigDownloadPage)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_EN_CHANGE(IDC_DOWNLOADDIR, OnChangeDownloaddir)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigDownloadPage message handlers

void CConfigDownloadPage::OnBrowse() 
{
	LPMALLOC pMalloc;
	SHGetMalloc(&pMalloc);
	char dirname[MAX_PATH];
	LPITEMIDLIST iil;
	BROWSEINFO bi;
	bi.hwndOwner = this->m_hWnd;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = dirname;
	bi.lpszTitle = "Choose Folder for Default";
	bi.ulFlags = 0;
	bi.lpfn = NULL;
	if((iil = SHBrowseForFolder(&bi)) == NULL)
	{
		// Cancel was pressed...
		pMalloc->Free(iil);
		pMalloc->Release();
		return;
	}
	if(SHGetPathFromIDList(iil, dirname))
		m_DownloadDir = dirname;

	if (m_DownloadDir.Right(1) != CString("\\") && m_DownloadDir.GetLength() > 0)
		m_DownloadDir += "\\";
	//SHGetMalloc(&pMalloc);
	pMalloc->Free(iil);
	pMalloc->Release();
	m_Browse.SetWindowText(m_DownloadDir);
	
	UpdateData(FALSE);
	if (DirectoryValid())
		parentSheet->SetWizardButtons(PSWIZB_FINISH | PSWIZB_BACK);
	else
		parentSheet->SetWizardButtons(PSWIZB_BACK);
}

BOOL CConfigDownloadPage::OnSetActive() 
{
	if (DirectoryValid())
		parentSheet->SetWizardButtons(PSWIZB_FINISH | PSWIZB_BACK);
	else
		parentSheet->SetWizardButtons(PSWIZB_BACK);
		
	return CPropertyPage::OnSetActive();
}

BOOL CConfigDownloadPage::DirectoryValid()
{
	UpdateData();
	char backupDir[MAX_TEMPBUF_LEN];
	_getcwd(backupDir, MAX_TEMPBUF_LEN);
	BOOL r = !_chdir(m_DownloadDir);
	_chdir(backupDir);
	return(r);
}

void CConfigDownloadPage::OnChangeDownloaddir() 
{
	if (DirectoryValid())
		parentSheet->SetWizardButtons(PSWIZB_FINISH | PSWIZB_BACK);
	else
		parentSheet->SetWizardButtons(PSWIZB_BACK);
}

BOOL CConfigDownloadPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_Browse.SetWindowText(m_DownloadDir);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
