/******************************************************************************
*
* AntiMafia
* Copyright (C) 2002 by [epidemiC] AntiMafia
* Newtella
* Copyright (C) 2000 by Newtella Inc.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
******************************************************************************/


// ConnectionPage.cpp : implementation file
//

#include "stdafx.h"
#include "AntiMafia.h"
#include "Core\common.h"
#include "Core\Buffer.h"
#include "Core\Object.h"
#include "Core\List.h"
#include "Core\String.h"
#include "Core\FileWorker.h"
#include "Core\Connection.h"
#include "Core\GnutellaWorker.h"
#include "Core\Base.h"
#include "ConnectionPage.h"

/////////////////////////////////////////////////////////////////////////////
// CConnectionPage property page

IMPLEMENT_DYNCREATE(CConnectionPage, CPropertyPage)

CConnectionPage::CConnectionPage() : CPropertyPage(CConnectionPage::IDD)
{
	//{{AFX_DATA_INIT(CConnectionPage)
	m_MinConnections = 0;
	m_MaxConnections = 0;
	m_IP = _T("connect.newtella.net:6346");
	m_Hosts = _T("");
	m_Suspend = FALSE;
	m_AcceptIncoming = FALSE ;
	m_Activity = _T("");
	//}}AFX_DATA_INIT
	m_psp.dwFlags &= ~PSH_HASHELP;
	dialogInitialized=FALSE;
}

CConnectionPage::~CConnectionPage()
{
}

void CConnectionPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConnectionPage)
	DDX_Control(pDX, IDC_MINSPIN, m_MinSpin);
	DDX_Control(pDX, IDC_MAXSPIN, m_MaxSpin);
	DDX_Control(pDX, IDC_CONNECTIONLIST, m_ConnectionList);
	DDX_Text(pDX, IDC_MINCONNECTIONS, m_MinConnections);
	DDX_Text(pDX, IDC_MAXCONNECTIONS, m_MaxConnections);
	DDX_Text(pDX, IDC_IP, m_IP);
	DDX_Text(pDX, IDC_HOSTS, m_Hosts);
	DDX_Check(pDX, IDC_SUSPEND, m_Suspend);
	DDX_Check(pDX, IDC_ACCEPTINCOMING, m_AcceptIncoming);
	DDX_Text(pDX, IDC_ACTIVITY, m_Activity);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConnectionPage, CPropertyPage)
	//{{AFX_MSG_MAP(CConnectionPage)
	ON_BN_CLICKED(IDC_ADDCONNECTION, OnAddconnection)
	ON_NOTIFY(NM_DBLCLK, IDC_CONNECTIONLIST, OnDblclkConnectionlist)
	ON_NOTIFY(UDN_DELTAPOS, IDC_MAXSPIN, OnDeltaposMaxspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_MINSPIN, OnDeltaposMinspin)
	ON_BN_CLICKED(IDC_ACCEPTINCOMING, OnAcceptincoming)
	ON_EN_KILLFOCUS(IDC_MAXCONNECTIONS, OnKillfocusMaxconnections)
	ON_EN_KILLFOCUS(IDC_MINCONNECTIONS, OnKillfocusMinconnections)
	ON_EN_CHANGE(IDC_IP, OnChangeIp)
	ON_BN_CLICKED(IDC_SUSPEND, OnSuspend)
	ON_WM_CONTEXTMENU()
	ON_WM_KEYDOWN()
	ON_NOTIFY(LVN_KEYDOWN, IDC_CONNECTIONLIST, OnKeydownConnectionlist)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConnectionPage message handlers

void CConnectionPage::OnAddconnection() 
{
	UpdateData();
	gnutella->Connect((LPCTSTR)m_IP);
	UpdatePage();
}

void CConnectionPage::OnDblclkConnectionlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int num = m_ConnectionList.GetNextItem(-1, LVNI_SELECTED);
	if (num == -1)
		return;
	*pResult = 0;
}

BOOL CConnectionPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	global.hWnd = ParentSheet->m_hWnd;
	
	UpdateData();
	int i;
	LV_COLUMN lvc;
	char *ctitle[4] = {"IP", "Status", "Packets", "Bandwidth"};
	int ctsize[4] = {global.ConnectionIP, global.ConnectionStatus, global.ConnectionPackets, global.ConnectionBandwidth} ; //{130, 90, 110, 80};
	for (i=0; i<4; i++)
	{
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
		lvc.iSubItem = i;
		lvc.cx = ctsize[i];
		lvc.fmt = LVCFMT_LEFT;
		lvc.pszText = ctitle[i];
		m_ConnectionList.InsertColumn(lvc.iSubItem, &lvc);
	}

	m_AcceptIncoming = global.options.acceptIncoming;
	m_MinConnections = global.options.minConnections;
	m_MaxConnections = global.options.maxConnections;
	m_MinSpin.SetRange(0, m_MaxConnections);
	m_MaxSpin.SetRange(m_MinConnections, 50);
	m_MinSpin.SetPos(m_MinConnections);
	m_MaxSpin.SetPos(m_MaxConnections);
	m_Suspend = TRUE ; //global.options.connectAutomatically;
	UpdateData(FALSE);

	dialogInitialized = TRUE;

	do
	{
		if (!InternetAttemptConnect(0)) break ;
			 
	} while (MessageBox("Error encountered while trying to connect", "Connecton Error", MB_RETRYCANCEL) == IDRETRY) ;

	global.AntiMafiaConnectionID = global.connectionID+1 ;
	gnutella->Connect("connect.newtella.net:6346") ;


	// from gtk gnutella
	gnutella->Connect("connect1.gnutellanet.com");
	gnutella->Connect("gnotella.fileflash.com");
	gnutella->Connect("connect2.gnutellanet.com");
	gnutella->Connect("public.bearshare.net");
	gnutella->Connect("connect3.gnutellanet.com");
	gnutella->Connect("gnet2.ath.cx");
	gnutella->Connect("connect1.bearshare.net");
	gnutella->Connect("gnutella-again.hostscache.com");	/* Multiple IPs, oh well */



	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CConnectionPage::UpdatePage()
{
	if (!m_hWnd)
		return(FALSE);
	if (!dialogInitialized)
		return(FALSE);

	int item;
	int i, newi, j;
	Connection *con;
	ConListInfo *cli;
	LV_ITEM lvi;

	UpdateData();
	gnutella->gnutellanetConnections.GetFirst(FALSE);
	for (i=0; con = (Connection *)gnutella->gnutellanetConnections.GetNext(); i++)
	{
		cli = (ConListInfo *)conInfo.GetData(con->id);
		if (cli)
		{
			cli->state = con->state;
			cli->sent = con->sent; cli->received = con->received; cli->dropped = con->dropped;
			cli->speed = con->speed;
			item = -1;
			for (; ; )
			{
				item = m_ConnectionList.GetNextItem(item, LVNI_ALL);
				if (item == -1)
					break;
				if (m_ConnectionList.GetItemData(item) == cli->id)
					break;
			}
			if (item != -1)
			{
				m_ConnectionList.SetItemText(item, 0, GetConListText(0, cli->ip, cli->port, cli->type));
				m_ConnectionList.SetItemText(item, 1, GetConListText(1, cli->type, cli->state, cli->temporary));
				m_ConnectionList.SetItemText(item, 2, GetConListText(2, cli->sent, cli->received, cli->dropped));
				m_ConnectionList.SetItemText(item, 3, GetConListText(3, cli->speed, 0, 0));
			}
		}
		else
		{
			lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE; 
			lvi.state = 0; 
			lvi.stateMask = 0; 
			lvi.pszText = "";
			lvi.iImage = 0;
			i = -1;
			for (; ; )
			{
				newi = m_ConnectionList.GetNextItem(i, LVNI_ALL);
				if (newi == -1)
				{
					newi = i+1;
					break;
				}
				if (newi > i+1)
					break;
				i = newi;
			}
			lvi.iItem = newi;
			lvi.iSubItem = 0;
			lvi.lParam = (LPARAM)con->id;
			cli = new ConListInfo;
			item = m_ConnectionList.InsertItem(&lvi);
			cli->ip = con->address.sin_addr.s_addr;
			cli->port = con->address.sin_port;
			cli->temporary = con->temporary;
			cli->socket = con->socket;
			cli->type = con->type;
			cli->id = con->id;
			cli->state = con->state;
			cli->sent = con->sent; cli->received = con->sent; cli->dropped = con->dropped;
			cli->speed = con->speed;
			conInfo.Add(cli->id, cli);
			m_ConnectionList.SetItemText(item, 0, GetConListText(0, cli->ip, cli->port, cli->type));
			m_ConnectionList.SetItemText(item, 1, GetConListText(1, cli->type, cli->state, cli->temporary));
			m_ConnectionList.SetItemText(item, 2, GetConListText(2, cli->sent, cli->received, cli->dropped));
			m_ConnectionList.SetItemText(item, 3, GetConListText(3, cli->speed, 0, 0));
		}
	}
	conInfo.GetFirst(FALSE);
	for (j=0; cli = (ConListInfo *)conInfo.GetNext(); j++)
	{
		con = (Connection *)gnutella->gnutellanetConnections.GetData(cli->id);
		if (!con)
		{
			item = -1;
			for (; ; )
			{
				item = m_ConnectionList.GetNextItem(item, LVNI_ALL);
				if (item == -1)
					break;
				if (m_ConnectionList.GetItemData(item) == cli->id)
					break;
			}
			if (item != -1)
			{
				m_ConnectionList.DeleteItem(item);
				conInfo.Remove(cli);
			}
		}

	}
// Update stats
	char stemp[MAX_TEMPBUF_LEN];
	sprintf(stemp, "%d", gnutella->hosts.Count());
	m_Hosts = stemp;
	sprintf(stemp, "%d", global.stats.perSecond);
	m_Activity = stemp;
	UpdateData(FALSE);

	return(TRUE);
}

char *CConnectionPage::GetConListText(int n, int p0, int p1, int p2)
{
	static char r[4096];
	struct in_addr ia;

	switch (n)
	{
	case 0:
		ia.s_addr = p0;
		if (p2 == CT_OUTGOING)
			sprintf(r, "%s:%d", inet_ntoa(ia), ntohs((WORD)p1));
		else
			sprintf(r, "%s", inet_ntoa(ia), ntohs((WORD)p1));
		break;
	case 1:
		if (p1 == GS_CONNECTED)
		{
			if (p2)
				sprintf(r, "Temporary");
			else
				sprintf(r, "OK");
		}
		else
			sprintf(r, "Connecting");
		break;
	case 2:
		if (p1)
			sprintf(r, "%d/%d/%d%%", p0, p1, p2*100/(p1+p2));
		else
			sprintf(r, "%d/%d/%d%%", p0, p1, 0);
		break;
	case 3:
		if (p0 > 1024*1024)
			sprintf(r, "%.1f MBps", p0/(double)(512*1024));
		else if (p0 > 1024)
			sprintf(r, "%.1f KBps", p0/(double)(512));
		else if (p0 > 0)
			sprintf(r, "%d Bps", p0);
		else
			sprintf(r, "Idle");
		break;
	default:
		sprintf(r, "Undefined");
		break;
	}
	return(r);
}

void CConnectionPage::OnAcceptincoming() 
{
	UpdateData();
	global.options.acceptIncoming = m_AcceptIncoming;
}

void CConnectionPage::OnDeltaposMaxspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;

	int maxpos = pNMUpDown->iPos + pNMUpDown->iDelta;
	if (maxpos >= HIWORD(m_MaxSpin.GetRange()))
	{
		m_MinSpin.SetRange(0, maxpos);
		global.options.maxConnections = maxpos;
	}

	*pResult = 0;
}

void CConnectionPage::OnDeltaposMinspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;

	int minpos = pNMUpDown->iPos + pNMUpDown->iDelta;
	if (minpos <= LOWORD(m_MinSpin.GetRange()))
	{
		m_MaxSpin.SetRange(minpos, 50);
		global.options.minConnections = minpos;
	}
	
	*pResult = 0;
}

void CConnectionPage::OnKillfocusMaxconnections() 
{
	UpdateData();
	if (m_MaxConnections < HIWORD(m_MaxSpin.GetRange()))
		m_MaxConnections = HIWORD(m_MaxSpin.GetRange());
	else if (m_MaxConnections > LOWORD(m_MaxSpin.GetRange()))
		m_MaxConnections = LOWORD(m_MaxSpin.GetRange());
	else
	{
		m_MinSpin.SetRange(0, m_MaxConnections);
		global.options.maxConnections = m_MaxConnections;
		return;
	}
	m_MinSpin.SetRange(0, m_MaxConnections);
	global.options.maxConnections = m_MaxConnections;

	UpdateData(FALSE);
}

void CConnectionPage::OnKillfocusMinconnections() 
{
	UpdateData();
	if (m_MinConnections < HIWORD(m_MinSpin.GetRange()))
		m_MinConnections = HIWORD(m_MinSpin.GetRange());
	else if (m_MinConnections > LOWORD(m_MinSpin.GetRange()))
		m_MinConnections = LOWORD(m_MinSpin.GetRange());
	else
	{
		m_MaxSpin.SetRange(m_MinConnections, 50);
		global.options.minConnections = m_MinConnections;
		return;
	}
	m_MaxSpin.SetRange(m_MinConnections, 50);
	global.options.minConnections = m_MinConnections;

	UpdateData(FALSE);
}

void CConnectionPage::OnChangeIp() 
{
	SetDefID(IDC_ADDCONNECTION);
}

void CConnectionPage::OnSuspend() 
{
	UpdateData();
	global.options.connectAutomatically = m_Suspend;
}

void CConnectionPage::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	UpdateData();
	CPoint point2 = point;
	m_ConnectionList.ScreenToClient(&point2);
	UINT hitFlags;
	int num = m_ConnectionList.HitTest(point2, &hitFlags);
	if (num == -1)
		return;

	Connection *con;
	CMenu menu;
	menu.CreatePopupMenu();
	menu.InsertMenu((UINT)-1, MF_BYPOSITION, IDM_SEARCH, _T("&Search..."));    
	menu.InsertMenu((UINT)-1, MF_BYPOSITION, IDM_REMOVE, _T("&Remove"));    
	UINT id = (UINT)menu.TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_NONOTIFY | TPM_RETURNCMD, point.x, point.y, this);
	switch (id)
	{
		case IDM_SEARCH:
			// ParentSheet->SetActivePage(this->searchPage);
			break;
		case IDM_REMOVE:
			num = -1;
			while ((num = m_ConnectionList.GetNextItem(num, LVNI_SELECTED)) != -1)
			{
				con = (Connection *)gnutella->gnutellanetConnections.GetData(m_ConnectionList.GetItemData(num));
				gnutella->gnutellanetConnections.Remove(con);
			}
			SetEvent(gnutellanetEvent);
			break;
	}
	UpdatePage();
}

void CConnectionPage::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CPropertyPage::OnKeyDown(nChar, nRepCnt, nFlags);
}


void CConnectionPage::OnKeydownConnectionlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;

	int num;
	Connection *con;
	switch (pLVKeyDow->wVKey)
	{
	case VK_DELETE:
		num = -1;
		while ((num = m_ConnectionList.GetNextItem(num, LVNI_SELECTED)) != -1)
		{
			con = (Connection *)gnutella->gnutellanetConnections.GetData(m_ConnectionList.GetItemData(num));
			gnutella->gnutellanetConnections.Remove(con);
		}
		SetEvent(gnutellanetEvent);
		break;
	}

	*pResult = 0;
}


void CConnectionPage::OnDestroy() 
{

	global.ConnectionIP = m_ConnectionList.GetColumnWidth(0) ;
	global.ConnectionStatus = m_ConnectionList.GetColumnWidth(1) ;
	global.ConnectionPackets = m_ConnectionList.GetColumnWidth(2) ;
	global.ConnectionBandwidth = m_ConnectionList.GetColumnWidth(3) ;
	
	CPropertyPage::OnDestroy();
	
}
