/******************************************************************************
*
* AntiMafia
* Copyright (C) 2002 by [epidemiC] AntiMafia
* Newtella
* Copyright (C) 2000 by Newtella Inc.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
******************************************************************************/



#include "..\stdafx.h"
#include <stdio.h>
#include <time.h>
#include "common.h"
#include "Buffer.h"
#include "Object.h"
#include "List.h"
#include "String.h"
#include "ErrorInfo.h"
#include "FileWorker.h"
#include "Connection.h"
#include "GnutellaWorker.h"
#include "Base.h"

// GLOBALS ////////////////////////////////////////////////

char ods[4096]={'\0'};
class Global global;
GnutellaWorker *gnutella=NULL;
List errors;

Options::Options()
{
}

Options::~Options()
{
}

Stats::Stats()
{
	received = 0;
	sent = 0;
	perSecond = 0;
	pings = 0;
	pongs = 0;
	searches = 0;
	searchresponses = 0;
	pushrequests = 0;
}

Stats::~Stats()
{
}

BOOL Stats::Dump(FILE *file)
{
	fprintf(file, "received: %d\n", received);
	fprintf(file, "sent: %d\n", sent);
	fprintf(file, "perSecond: %d\n", perSecond);
	fprintf(file, "pings: %d\n", pings);
	fprintf(file, "pongs: %d\n", pongs);
	fprintf(file, "searches: %d\n", searches);
	fprintf(file, "searchresponses: %d\n", searchresponses);
	fprintf(file, "pushrequests: %d\n", pushrequests);
	return(TRUE);
}

Global::Global()
{
	hWnd = NULL;
	hInst = NULL;
	memset(&sessionGUID, 0, sizeof(GLUID));
	localIP = 0;
	clientFirewalled = FALSE;
	connectionID = 0;
}

Global::~Global()
{
}

BOOL myhash(BYTE *buf, int buflen, HASH hash)
{
	BYTE *p = buf;
	int i;
	DWORD h=0, M=3121238909;
	if (buflen == 16)
	{
		for (i = 0; i < 16; i++)
		{
			h ^= (64*h + *p++);
			h %= M;
		}
		memcpy(hash, buf, 16);
		memcpy(hash+16, &h, 4);
	}
	else
	{
		for (i = 0; i < buflen; i++)
		{
			h ^= (64*h + *p++);
			h %= M;
			if (buflen/5 == i)
				memcpy(hash, &h, 4);
			if (buflen/5 == i/2)
				memcpy(hash+4, &h, 4);
			if (buflen/5 == i/3)
				memcpy(hash+8, &h, 4);
			if (buflen/5 == i/4)
				memcpy(hash+12, &h, 4);
		}
		memcpy(hash+16, &h, 4);
	}
	return(TRUE);
}

char *inet_iptoa(DWORD ip, WORD port)
{
	static char r[MAX_TEMPBUF_LEN];
	struct in_addr ia;

	ia.s_addr = ip;
	if (port)
		sprintf(r, "%s:%d", inet_ntoa(ia), ntohs(port));
	else
		sprintf(r, "%s", inet_ntoa(ia));

	return(r);
}



char *WSAErrorString(int e)
{
	char *r;
	switch (e)
	{
	case WSAEINTR:
		r = "WSAEINTR";
		break;
	case WSAEBADF:
		r = "WSAEBADF";
		break;
	case 10013:
		r = "WSEACCES";
		break;
	case WSAEFAULT:
		r = "WSAEFAULT";
		break;
	case WSAEINVAL:
		r = "WSAEINVAL";
		break;
	case WSAEMFILE:
		r = "WSAEMFILE";
		break;
	case WSAEWOULDBLOCK:
		r = "WSAEWOULDBLOCK";
		break;
	case WSAEINPROGRESS:
		r = "WSAEINPROGRESS";
		break;
	case WSAEALREADY:
		r = "WSAEALREADY";
		break;
	case WSAENOTSOCK:
		r = "WSAENOTSOCK";
		break;
	case WSAEDESTADDRREQ:
		r = "WSAEDESTADDRREQ";
		break;
	case WSAEMSGSIZE:
		r = "WSAEMSGSIZE";
		break;
	case WSAEPROTOTYPE:
		r = "WSAEPROTOTYPE";
		break;
	case WSAENOPROTOOPT:
		r = "WSAENOPROTOOPT";
		break;
	case WSAEPROTONOSUPPORT:
		r = "WSAEPROTONOSUPPORT";
		break;
	case WSAESOCKTNOSUPPORT:
		r = "WSAESOCKTNOSUPPORT";
		break;
	case WSAEOPNOTSUPP:
		r = "WSAEOPNOTSUPP";
		break;
	case WSAEPFNOSUPPORT:
		r = "WSAEPFNOSUPPORT";
		break;
	case WSAEAFNOSUPPORT:
		r = "WSAEAFNOSUPPORT";
		break;
	case WSAEADDRINUSE:
		r = "WSAEADDRINUSE";
		break;
	case WSAEADDRNOTAVAIL:
		r = "WSAEADDRNOTAVAIL";
		break;
	case WSAENETDOWN:
		r = "WSAENETDOWN";
		break;
	case WSAENETUNREACH:
		r = "WSAENETUNREACH";
		break;
	case WSAENETRESET:
		r = "WSAENETRESET";
		break;
	case WSAECONNABORTED:
		r = "WSAECONNABORTED";
		break;
	case WSAECONNRESET:
		r = "WSAECONNRESET";
		break;
	case WSAENOBUFS:
		r = "WSAENOBUFS";
		break;
	case WSAEISCONN:
		r = "WSAEISCONN";
		break;
	case WSAENOTCONN:
		r = "WSAENOTCONN";
		break;
	case WSAESHUTDOWN:
		r = "WSAESHUTDOWN";
		break;
	case WSAETOOMANYREFS:
		r = "WSAETOOMANYREFS";
		break;
	case WSAETIMEDOUT:
		r = "WSAETIMEDOUT";
		break;
	case WSAECONNREFUSED:
		r = "WSAECONNREFUSED";
		break;
	case WSAELOOP:
		r = "WSAELOOP";
		break;
	case WSAENAMETOOLONG:
		r = "WSAENAMETOOLONG";
		break;
	case WSAEHOSTDOWN:
		r = "WSAEHOSTDOWN";
		break;
	case WSAEHOSTUNREACH:
		r = "WSAEHOSTUNREACH";
		break;
	case WSASYSNOTREADY:
		r = "WSASYSNOTREADY";
		break;
	case WSAVERNOTSUPPORTED:
		r = "WSAVERNOTSUPPORTED";
		break;
	case WSANOTINITIALISED:
		r = "WSANOTINITIALISED";
		break;
	case WSAHOST_NOT_FOUND:
		r = "WSAHOST_NOT_FOUND";
		break;
	case WSATRY_AGAIN:
		r = "WSATRY_AGAIN";
		break;
	case WSANO_RECOVERY:
		r = "WSANO_RECOVERY";
		break;
	case WSANO_DATA:
		r = "WSANO_DATA";
		break;
	default:
		r = "UNKNOWN";
		break;
	}
	return(r);
}

