/******************************************************************************
*
* AntiMafia
* Copyright (C) 2002 by [epidemiC] AntiMafia
* Newtella
* Copyright (C) 2000 by Newtella Inc.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
******************************************************************************/


#include "..\stdafx.h"
#include <string.h>
#include <direct.h>
#include <stdio.h>
#include <io.h>
#include "common.h"
#include "Buffer.h"
#include "Object.h"
#include "List.h"
#include "String.h"
#include "FileWorker.h"
#include "Connection.h"
#include "GnutellaWorker.h"
#include "Base.h"

FileWorker::FileWorker()
{
	totalSize = 0;
	cIndexIndexes = NULL;
	cIndex.SetPageSize(50000);
}

FileWorker::~FileWorker()
{
	if (cIndexIndexes)
	{
		delete [] cIndexIndexes;
		cIndexIndexes = NULL;
	}
}

BOOL FileWorker::BuildMP3Index()
{
	int num=0;
	FileInfo *fi;
	String s1, mp3type("mp3");

	fileList.GetFirst(FALSE);
	for (; fi = (FileInfo *)fileList.GetNext(); )
	{
		s1 = fi->name.RightOfLast('.');
		if (s1 == mp3type)
			fi->ext.id3 = GetID3(fi->directory + fi->name);
	}

	return(TRUE);
}

BOOL FileWorker::BuildIndex()
{
	fileList.Reset();
// Check whether there really is a directory to search
	if (!global.options.shareDir.GetLength() && !global.options.downloadDir.GetLength())
		return(TRUE);
// Count the file extensions
	int numspecs = 1;
// Parse the file extensions
	String *specs = new String[numspecs];
	int i=0;
	specs[0] = "love";
// Make a list of all the indexed directories
	char backup_dir[MAX_TEMPBUF_LEN];
	_getcwd(backup_dir, MAX_TEMPBUF_LEN);
	directoryList.Reset();
	String s=global.options.shareDir, s2;
	int count = s.Count(';')+1;
	for (i=0; i<count; i++)
	{
		s2 = s.LeftOf(';');
		s = s.RightOf(';');
		MakeDirectoryList(s2);
	}
	if (global.options.downloadDir) MakeDirectoryList(global.options.downloadDir) ;
// Index the files
	int index=0;
	long findhandle;
	char curspec[MAX_TEMPBUF_LEN];
	struct _finddata_t fd;
	String *str;
	FileInfo *fi;
	directoryList.GetFirst(FALSE);
	while (str = (String *)directoryList.GetNext())
	{
		if (_chdir(*str))
			continue;
		for (i=0; i<numspecs; i++)
		{
			strcpy(curspec, "*.");
			strcat(curspec, specs[i]);
			findhandle = _findfirst(curspec, &fd);
			if (findhandle == -1)
				continue;
			do
			{
				fi = new FileInfo;
				fi->index = index;
				fi->size = fd.size;
				fi->name = fd.name;
				fi->directory = *str;
				totalSize += fd.size/1024;
				fileList.Add(index++, fi);
			} while (!_findnext(findhandle, &fd));
		}
	}
	_chdir(backup_dir);
	delete [] specs;

	CompileIndex();

	return(TRUE);
}

BOOL FileWorker::CompileIndex()
{
	if (cIndexIndexes)
		delete [] cIndexIndexes;
	cIndexIndexes = new int[fileList.Count()];

	int i=0, totalLength=0;
	char tbuf[MAX_TEMPBUF_LEN], *tb;
	fileList.GetFirst(FALSE);
	FileInfo *fi;
	while (fi = (FileInfo *)fileList.GetNext())
	{
		cIndexIndexes[i++] = totalLength;

		tb=tbuf;
		strcpy(tb, fi->name);
		strcat(tb, " ");
		strcat(tb, fi->directory);
		strcat(tb, " ");
		strcat(tb, fi->ext.id3);
		strlwr(tbuf);
		tb += strlen(tbuf) + 1;

		cIndex.ReAlloc(tb - tbuf, TRUE);
		memcpy(cIndex + totalLength, tbuf, tb - tbuf);
		totalLength += tb - tbuf;
	}
	
	return(TRUE);
}

BOOL FileWorker::MakeDirectoryList(String dir)
{
	struct _finddata_t fd;
	if (_chdir(dir) == -1) return FALSE ;
	long findhandle = _findfirst("*.*", &fd);
	String *ddir = new String(dir);
	directoryList.Add(ddir);
	if (findhandle == -1)
		return(TRUE);
	do
	{
		if (!(fd.attrib & _A_SUBDIR))
			continue;
		if (!strcmp(fd.name, "."))
			continue;
		if (!strcmp(fd.name, ".."))
			continue;
		MakeDirectoryList(dir + String(fd.name) + String("\\"));
	} while (!_findnext(findhandle, &fd));
	return(TRUE);
}

int FileWorker::SearchFile(String search, List *list)
{
// Split the query at spaces
	String search2 = search;
	search2.RemoveNonAlphaNums();
	search2.RemoveDoubleSpaces();
	int tokens = search2.Count(' ') + 1;
	String *s = new String[tokens];
	for (int i=0; i<tokens-1; i++)
	{
		s[i] = search2.LeftOf(' ');
		search2 = search2.RightOf(' ');
	}
	s[i] = search2;
// Check for too short query strings
	BOOL *sOK = new BOOL[tokens];
	int realTokens=tokens;
	for (i=0; i<tokens; i++)
	{
		if (s[i].GetLength() <= 2)
		{
			sOK[i] = FALSE;
			realTokens--;
		}
		else
			sOK[i] = TRUE;
	}
	if (!realTokens)
	{
		delete [] s;
		delete [] sOK;
		return(0);
	}
// Search for files
	int j, found=0, count = fileList.Count();
	FileInfo *fi, *fi2;
	
	for (i=0; i<count; i++)
	{
		for (j=0; j<tokens; j++)
		{
			if (!sOK[j])
				continue;
			if (!strstr(cIndex + cIndexIndexes[i], s[j]))
				break;
		}
		if (j == tokens)
		{
			fi = (FileInfo *)fileList.GetData(i);
			fi2 = new FileInfo(*fi);
			list->Add(found++, fi2);
		}
	}
// Clean up
	delete [] s;
	delete [] sOK;

	return(found);
}

int FileWorker::Matches(FileInfo fi, String search)
{
	String token;

	for (int i=0; search.GetWord(i, token); i++)
	{
		if (fi.FindNoCase(token) == -1)
			return(FALSE);
	}

	return(TRUE);
}

String FileWorker::GetID3(String filename)
{
	String s;
	FILE *mp3file;

	mp3file = fopen(filename, "rb");
	if (!mp3file)
		return(s);

	BYTE footer[128];
	fseek(mp3file, -128, SEEK_END);
	fread(footer, 1, 128, mp3file);
	if (memcmp(footer, "TAG", 3))
		return(s);
	char str[125];
	memcpy(str, footer+3, 124);
	str[124] = '\0';
	s += String(str);

	fclose(mp3file);

	return(s);
}

int FileWorker::CountFiletype(String type)
{
	int num=0;
	FileInfo *fi;
	String s1;

	fileList.GetFirst(FALSE);
	for (; fi = (FileInfo *)fileList.GetNext(); )
	{
		s1 = fi->name.RightOfLast('.');
		if (s1 == type)
			num++;
	}
	return(num);
}

int FileWorker::TotalSize()
{
	return(totalSize);
}

FileInfo::FileInfo()
{
	index = 0;
	size = 0;
	hostSpeed = 0;
	hostIP = 0;
	hostPort = 0;
	memset(guid, 0, sizeof(GLUID));
	memset(clientGUID, 0, sizeof(GLUID));
}

FileInfo::~FileInfo()
{
}

FileInfo::FileInfo(FileInfo &fi2)
{
	directory = fi2.directory;
	hostIP = fi2.hostIP;
	hostPort = fi2.hostPort;
	hostSpeed = fi2.hostSpeed;
	index = fi2.index;
	name = fi2.name;
	size = fi2.size;
	ext = fi2.ext;
	memcpy(guid, fi2.guid, sizeof(GLUID));
	memcpy(clientGUID, fi2.clientGUID, sizeof(GLUID));
}

BOOL FileInfo::FindNoCase(String token)
{
	if (name.FindNoCase(token) != -1)
		return(TRUE);
	if (directory.FindNoCase(token) != -1)
		return(TRUE);
	return(FALSE);
}

BOOL FileInfo::Dump(FILE *file)
{
	int rval;
	rval = fprintf(file, "%d\t%s\t%s\t%d\n", index, (LPCSTR)directory, (LPCSTR)name, size);
	if (rval < 0)
		return(FALSE);

	return(TRUE);
}

BOOL FileInfo::Serialize(FILE *file, BOOL store)
{
	const int serializeVersion=FILEINFO_SERIALIZEVERSION ;
	int fileVersion;

	if (store)
	{
		STORE_VAR(serializeVersion);

		STORE_VAR(hostIP);
		STORE_VAR(hostPort);
		STORE_VAR(hostSpeed);
		STORE_VAR(index);
		STORE_VAR(size);
		STORE_VAR(guid);
		STORE_VAR(clientGUID);
		STORE_VAR(SystemTime);
		STORE_SUBCLASS(name);
		STORE_SUBCLASS(directory);
		STORE_SUBCLASS(ext);
	}
	else
	{
		CHECK_VERSION();

		LOAD_VAR(hostIP);
		LOAD_VAR(hostPort);
		LOAD_VAR(hostSpeed);
		LOAD_VAR(index);
		LOAD_VAR(size);
		LOAD_VAR(guid);
		LOAD_VAR(clientGUID);
		LOAD_VAR(SystemTime);
		LOAD_SUBCLASS(name);
		LOAD_SUBCLASS(directory);
		LOAD_SUBCLASS(ext);
	}
	return(TRUE);
serializeFailed:
	return(FALSE);
}

FileInfoEx::FileInfoEx()
{
}

FileInfoEx::~FileInfoEx()
{
}

FileInfoEx::FileInfoEx(FileInfoEx &fi2)
{
	id3 = fi2.id3;
	zip = fi2.zip;
}

BOOL FileInfoEx::FindNoCase(String token)
{
	if (id3.FindNoCase(token) != -1)
		return(TRUE);
	if (zip.FindNoCase(token) != -1)
		return(TRUE);
	return(FALSE);
}

BOOL FileInfoEx::Serialize(FILE *file, BOOL store)
{
	const int serializeVersion=1;
	int fileVersion;

	if (store)
	{
		STORE_VAR(serializeVersion);

		STORE_SUBCLASS(id3);
		STORE_SUBCLASS(zip);
	}
	else
	{
		CHECK_VERSION();

		LOAD_SUBCLASS(id3);
		LOAD_SUBCLASS(zip);
	}
	return(TRUE);
serializeFailed:
	return(FALSE);
}

