/******************************************************************************
*
* AntiMafia
* Copyright (C) 2002 by [epidemiC] AntiMafia
* Newtella
* Copyright (C) 2000 by Newtella Inc.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
******************************************************************************/


class String : public Object
{
public:
	String();
	~String();
	String(const String &string2);
	String(const char *string2);
	String(const char *string2, int len);
	int GetLength() const;
	operator LPCSTR() const;
	BOOL Concat(const String& string2);
	int operator==(const String& string2) const;
	int operator!=(const String& string2) const;
	const String& operator=(const String& string2);
	const String& operator=(const char *string2);
	String operator+(String& string2);
	String operator+=(String& string2);
	String operator+=(LPCSTR string2);
	String Right(unsigned int n) const;
	String Left(unsigned int n) const;
	String RightOf(char chr) const;
	String RightOfLast(char chr) const;
	String LeftOf(char chr) const;
	String LeftOfLast(char chr) const;
	int Count(char chr) const;
	int StrStr(String token) const;
	int Strchr(char chr) const;
	int Strrchr(char chr) const;
	BOOL RemoveDoubleSpaces();
	BOOL RemoveNonAlphaNums();
	int Find(String token) const;
	int FindNoCase(String token) const;
	BOOL GetLine(unsigned int n, String &r) const;
	BOOL GetWord(unsigned int n, String &r) const;
	String GetSubstring(int start, int end) const;
	BOOL MatchWildcard(String w);
	BOOL ToLower();
	BOOL IsHexDecString();
	BOOL Serialize(FILE *file, BOOL store);
private:
	char *data;
	unsigned int length;
};

