#include "stdafx.h"
#include "Core\common.h"
#include "Core\Buffer.h"
#include "Core\Object.h"
#include "Core\List.h"
#include "Core\String.h"
#include "Core\ErrorInfo.h"
#include "Core\FileWorker.h"
#include "Core\Connection.h"
#include "Core\GnutellaWorker.h"
#include "Core\Base.h"
#include "Logger.h"
#include "MyTime.h"



Logger *Logger::s_this = 0;
const char *Logger::logfilename = "c:\\antimafiadebug.log";

Logger::Logger()
{
	FILE *fp;

	m_bDebug = false;
	fp = fopen("debugantimafia.txt", "r");
	if (fp)
	{
		m_bDebug = true;
		fclose(fp);
	}

	if (!m_bDebug)
		return;
	fp = fopen(logfilename, "w");
	if (fp != 0)
	{
		CTime now = CMyTime::GetUTime();
		fprintf(fp, "------------------------------------------------------------\n");
		fprintf(fp, "AntiMafia started at %s\n", (const char *) now.Format("%H:%M:%S"));
		fclose(fp);
	}
}

int Logger::Log(const char *format, ...)
{
	FILE *fp;
	int ret = 0;

	if (!m_bDebug)
		return 0;

	fp = fopen(logfilename, "a");
	if (fp != 0)
	{
		va_list marker;
		va_start(marker, format);
		ret = vfprintf(fp, format, marker);
		va_end(marker);
		fclose(fp);
	}
	return ret;
}

Logger *Logger::Instance()
{
	if (0 == s_this)
		s_this = new Logger();
	return s_this;
}

void Logger::LogGnutellaHeader(GnutellaHeader& gh)
{
	if (!m_bDebug)
		return;

	Log("GnutellaHeader:\n");
	Log("GUID: %x%x%x%x%x%x%x%x%x%x%x%x%x%x%x%x\n",
		int(gh.guid[0]),
		int(gh.guid[1]),
		int(gh.guid[2]),
		int(gh.guid[3]),
		int(gh.guid[4]),
		int(gh.guid[5]),
		int(gh.guid[6]),
		int(gh.guid[7]),
		int(gh.guid[8]),
		int(gh.guid[9]),
		int(gh.guid[10]),
		int(gh.guid[11]),
		int(gh.guid[12]),
		int(gh.guid[13]),
		int(gh.guid[14]),
		int(gh.guid[15])
	);
	Log("Function: %d\n", (int)gh.function);
	Log("ttl: %d\n", (int)gh.ttl);
	Log("hops: %d\n", (int)gh.hops);
	Log("length: %d\n", (int)gh.length);
}

void Logger::LogGnutellaQuery(GnutellaQuery& gq)
{
	if (!m_bDebug)
		return;

	Log("minspeed: %d\n", (int)gq.minspeed);
}

